﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using Telerik.Windows.Controls;

namespace ScheduleViewWpf
{

    public class CustomGroupHeaderContentTemplateSelector : ScheduleViewDataTemplateSelector
    {
        public DataTemplate DayHorizontalDateTemplate { set; get; }
        public DataTemplate WeekHorizontalDateTemplate { set; get; }
        public DataTemplate MonthHorizontalDateTemplate { set; get; }
        public DataTemplate TimelineHorizontalDateTemplate { set; get; }
        public DataTemplate DayVerticalDateTemplate { set; get; }
        public DataTemplate WeekVerticalDateTemplate { set; get; }
        public DataTemplate MonthVerticalDateTemplate { set; get; }
        public DataTemplate TimelineVerticalDateTemplate { set; get; }
        public DataTemplate DayHorizontalResourceTemplate { set; get; }
        public DataTemplate WeekHorizontalResourceTemplate { set; get; }
        public DataTemplate MonthHorizontalResourceTemplate { set; get; }
        public DataTemplate TimelineHorizontalResourceTemplate { set; get; }
        public DataTemplate DayVerticalResourceTemplate { set; get; }
        public DataTemplate WeekVerticalResourceTemplate { set; get; }
        public DataTemplate MonthVerticalResourceTemplate { set; get; }
        public DataTemplate TimelineVerticalResourceTemplate { set; get; }

        public override DataTemplate SelectTemplate(object item, DependencyObject container, ViewDefinitionBase activeViewDefinition)
        {
            CollectionViewGroup cvg = item as CollectionViewGroup;

            if (cvg != null && cvg.Name is IResource)
            {
                if (activeViewDefinition.GetOrientation() == Orientation.Vertical)
                {
                    switch (activeViewDefinition.Title)
                    {
                        case "Day":
                            {
                                if (DayHorizontalResourceTemplate != null)
                                {
                                    return DayHorizontalResourceTemplate;
                                }
                                break;
                            }
                        case "Week":
                            {
                                if (WeekHorizontalResourceTemplate != null)
                                {
                                    return WeekHorizontalResourceTemplate;
                                }
                                break;
                            }
                        case "Month":
                            {
                                if (MonthHorizontalResourceTemplate != null)
                                {
                                    return MonthHorizontalResourceTemplate;
                                }
                                break;
                            }
                        case "Timeline":
                            {
                                if (TimelineHorizontalResourceTemplate != null)
                                {
                                    return TimelineHorizontalResourceTemplate;
                                }
                                break;
                            }
                    }
                }
                else
                {
                    switch (activeViewDefinition.ToString())
                    {
                        case "Day":
                            {
                                if (DayVerticalResourceTemplate != null)
                                {
                                    return DayVerticalResourceTemplate;
                                }
                                break;
                            }
                        case "Week":
                            {
                                if (WeekVerticalResourceTemplate != null)
                                {
                                    return WeekVerticalResourceTemplate;
                                }
                                break;
                            }
                        case "Month":
                            {
                                if (MonthVerticalResourceTemplate != null)
                                {
                                    return MonthVerticalResourceTemplate;
                                }
                                break;
                            }
                        case "Timeline":
                            {
                                if (TimelineVerticalResourceTemplate != null)
                                {
                                    return TimelineVerticalResourceTemplate;
                                }
                                break;
                            }
                    }
                }
            }

            if (cvg != null && cvg.Name is DateTime)
            {
                if (activeViewDefinition.GetOrientation() == Orientation.Vertical)
                {
                    switch (activeViewDefinition.Title)
                    {
                        case "Day":
                            {
                                if (DayHorizontalDateTemplate != null)
                                {
                                    return DayHorizontalDateTemplate;
                                }
                                break;
                            }
                        case "Week":
                            {
                                if (WeekHorizontalDateTemplate != null)
                                {
                                    return WeekHorizontalDateTemplate;
                                }
                                break;
                            }
                        case "Month":
                            {
                                if (MonthHorizontalDateTemplate != null)
                                {
                                    return MonthHorizontalDateTemplate;
                                }
                                break;
                            }
                        case "Timeline":
                            {
                                if (TimelineHorizontalDateTemplate != null)
                                {
                                    return TimelineHorizontalDateTemplate;
                                }
                                break;
                            }
                    }
                }
                else
                {
                    switch (activeViewDefinition.ToString())
                    {
                        case "Day":
                            {
                                if (DayVerticalDateTemplate != null)
                                {
                                    return DayVerticalDateTemplate;
                                }
                                break;
                            }
                        case "Week":
                            {
                                if (WeekVerticalDateTemplate != null)
                                {
                                    return WeekVerticalDateTemplate;
                                }
                                break;
                            }
                        case "Month":
                            {
                                if (MonthVerticalDateTemplate != null)
                                {
                                    return MonthVerticalDateTemplate;
                                }
                                break;
                            }
                        case "Timeline":
                            {
                                if (TimelineVerticalDateTemplate != null)
                                {
                                    return TimelineVerticalDateTemplate;
                                }
                                break;
                            }
                    }
                }
            }

            return base.SelectTemplate(item, container, activeViewDefinition);
        }
    }

}
