﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.ScheduleView;

namespace ScheduleViewWpf
{
    public class ViewModel : ViewModelBase
    {
        private ObservableCollection<Appointment> _appointments = new ObservableCollection<Appointment>();

        private ResourceType _mechanicAllocationResourceType = new ResourceType("Rooms");

        private ObservableCollection<ResourceType> _resourceTypes = new ObservableCollection<ResourceType>();

        private GroupDescriptionCollection _groupDescriptions;

        public ViewModel()
        {
        }

        public ObservableCollection<Appointment> Appointments
        {
            get
            {
                return _appointments;
            }
            set
            {
                if (_appointments != value)
                {
                    _appointments = value;

                    OnPropertyChanged("Appointments");
                }
            }
        }

        public ObservableCollection<ResourceType> ResourcesTypes
        {
            get
            {
                return _resourceTypes;
            }
        }

        public GroupDescriptionCollection GroupDescriptions
        {
            get
            {
                if (_groupDescriptions == null)
                {
                    _groupDescriptions = new GroupDescriptionCollection();

                    ResourceGroupDescription groupDescription = new ResourceGroupDescription();

                    groupDescription.ResourceType = "Rooms";

                    _groupDescriptions.Add(groupDescription);
                }

                return _groupDescriptions;
            }
        }

        public Func<object, bool> GroupFilter
        {
            get
            {
                return GroupFilterFunc;
            }
        }

        private bool GroupFilterFunc(object groupName)
        {
            bool ret = true;

            var res = groupName as Resource;

            if (res != null && res.DisplayName == "Res1")
            {
                ret = false;
            }

            return ret;
        }

        private DelegateCommand _visibleRangeChangedCommand;

        public DelegateCommand VisibleRangeChangedCommand
        {
            get
            {
                if (_visibleRangeChangedCommand == null)
                {
                    _visibleRangeChangedCommand = new DelegateCommand(ExecuteVisibleRangeChangedCommand, CanExecuteVisibleRangeChangedCommand);
                }

                return _visibleRangeChangedCommand;
            }
        }

        private void ExecuteVisibleRangeChangedCommand(object parameter)
        {
            _resourceTypes.Clear();
            _mechanicAllocationResourceType.Resources.Clear();

            _mechanicAllocationResourceType.Resources.Add(new Resource("Room1"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room2"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room3"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room4"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room5"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room6"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room7"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room8"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room9"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room10"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room11"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room12"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room13"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room14"));
            _mechanicAllocationResourceType.Resources.Add(new Resource("Room15"));

            ObservableCollection<Appointment> apps = new ObservableCollection<Appointment> 
            { 
             new Appointment { Start = DateTime.Now, End= DateTime.Now.AddHours(1)},
             new Appointment { Start = DateTime.Now, End= DateTime.Now.AddHours(1)},
             new Appointment { Start = DateTime.Now, End= DateTime.Now.AddHours(1)},
             new Appointment { Start = DateTime.Now, End= DateTime.Now.AddHours(1)},
             new Appointment { Start = DateTime.Now, End= DateTime.Now.AddHours(1)},
             new Appointment { Start = DateTime.Now, End= DateTime.Now.AddHours(1)},
            };

            for (int i = 0; i < apps.Count; i++)
            {
                apps[i].Resources.Add(_mechanicAllocationResourceType.Resources[i]);
            }

            Appointments = apps;

            _resourceTypes.Add(_mechanicAllocationResourceType);
        }

        private bool CanExecuteVisibleRangeChangedCommand(object parameter)
        {
            return true;
        }

    }
}
